﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Data;
using Infragistics.Web.UI.GridControls;

public partial class _Default : System.Web.UI.Page
{
    protected void Page_Load(object sender, EventArgs e)
    {
        if(!IsPostBack)
            Session.Add("MySource", MakeTable());

        ((DropDownProvider)WebDataGrid1.EditorProviders["ProfileProvider"]).EditorControl.DataSource = MakeTable();
        ((DropDownProvider)WebDataGrid1.EditorProviders["ProfileProvider"]).EditorControl.TextField = "Item";

        this.WebDataGrid1.DataSource = (DataTable)Session["MySource"]; 
        this.WebDataGrid1.DataBind();
    }

    private DataTable MakeTable()
    {
        // Create a new DataTable.
        System.Data.DataTable table = new DataTable("Table");
        // Declare variables for DataColumn and DataRow objects.
        DataColumn column;
        DataRow row;

        // Create new DataColumn, set DataType, 
        // ColumnName and add to DataTable.    
        column = new DataColumn();
        column.DataType = System.Type.GetType("System.Int32");
        column.ColumnName = "id";
        column.ReadOnly = false;
        // Add the Column to the DataColumnCollection.
        table.Columns.Add(column);

        // Create column.
        column = new DataColumn();
        column.DataType = System.Type.GetType("System.String");
        column.ColumnName = "Item";
        column.AutoIncrement = false;
        column.Caption = "Item";
        column.ReadOnly = false;
        column.Unique = false;
        // Add the column to the table. 
        table.Columns.Add(column);
        
        // Make the ID column the primary key column.
        DataColumn[] PrimaryKeyColumns = new DataColumn[1];
        PrimaryKeyColumns[0] = table.Columns["id"];
        table.PrimaryKey = PrimaryKeyColumns;
        
        for (int i = 0; i <= 10; i++)
        {
            row = table.NewRow();
            row["id"] = i;
            row["Item"] = "Item " + i;        
            table.Rows.Add(row);
        }
        return table;

    }

    protected void WebDataGrid1_RowAdding(object sender, Infragistics.Web.UI.GridControls.RowAddingEventArgs e)
    {
        try
        {
            DataTable dt = (DataTable)Session["MySource"];
            DataRow newRow = dt.NewRow();
            newRow.SetField<string>("Name", (string)e.Values["Name"]);
            dt.Rows.Add(newRow);
            WebDataGrid1.DataSource = dt;
            WebDataGrid1.DataBind();
        }
        catch (Exception) { }
    }
}